﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.51
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub

Sub SetTableHeaderWrap(Table As JavaObject, PrefHeight As Int)

	Dim HeaderRow As Pane = Table.RunMethod("lookup",Array("TableHeaderRow"))
	For Each N As JavaObject In HeaderRow.GetAllViewsRecursive
		If N Is Label Then
			Dim NL As Label = N
			If PrefHeight <> -1 Then NL.PrefHeight = PrefHeight
			'Seems to lose the text centering
			CSSUtils.SetStyleProperty(NL,"-fx-text-alignment","center")
			N.RunMethod("setWrapText",Array(True))
		End If
	Next
End Sub

'Parent - The Node that ontains a scrollbar i.e. ListView, TableView etc.
'Orientation - can be VERTICAL or HORIONTAL
Public Sub GetScrollBar(Parent As JavaObject, ORIENTATION As String) As JavaObject
	
	'Get the attached scrollbars
	Dim Arr() As Object = GetScrollBars(Parent)
	
	For Each N As Node In Arr
		'Check this object is a scrolbar
		If GetType(N) = "com.sun.javafx.scene.control.skin.VirtualScrollBar" Or GetType(N) = "javafx.scene.control.ScrollBar" Then
			Dim SB As JavaObject = N
			'Get the orientation of the scrollbar as a string
			Dim BarOrientation As String = SB.RunMethodJO("getOrientation",Null).RunMethod("toString",Null)
			'Required Orientation is VERTICAL or BOTH
			If ORIENTATION  = BarOrientation Then
				Return N
			End If
		End If
	Next
	Dim Failed As JavaObject
	Return Failed
End Sub

Private Sub GetScrollBars(Parent As JavaObject) As Object()
	'Get a set that contains the scrollbars attached to the parent and convert it to an array
	Return Parent.RunMethodJO("lookupAll",Array(".scroll-bar")).RunMethod("toArray",Null)
End Sub

'Extract text between EncStart and EncEnd
Public Sub GetEnclosed(EncStart As String,EncEnd As String, Source As String) As String
	Dim First As Int = Source.IndexOf(EncStart) + EncStart.Length
	If First = -1 Then Return ""
	Dim Second As Int = Source.LastIndexOf(EncEnd)
	If Second = -1 Then Return ""
	If First > Second Then Return ""
	Return Source.SubString2(First,Second)
End Sub
'Extract text between EncStart and EncEnd
Public Sub GetEnclosedFirstInclusive(EncStart As String,EncEnd As String, Source As String) As String
	Dim First As Int = Source.IndexOf(EncStart)
	If First = -1 Then Return ""
	Dim Second As Int = Source.IndexOf2(EncEnd,First)
	If Second = -1 Then Return ""
	If First > Second Then Return ""
	Return Source.SubString2(First,Second)
End Sub

'Extract text between EncStart and EncEnd
Public Sub GetEnclosedFirstInclusivePos(EncStart As String,EncEnd As String, Source As String,First As Int) As String
	If First = -1 Then Return ""
	Dim Second As Int = Source.IndexOf2(EncEnd,First)
	If Second = -1 Then Return ""
	If First > Second Then Return ""
	Return Source.SubString2(First,Second)
End Sub

'Count the number of occurences ot TargetStr In StringToSearch
Public Sub StringCount(TargetStr As String, StringToSearch As String,IgnoreCase As Boolean) As Int
	If IgnoreCase Then
		StringToSearch = StringToSearch.ToLowerCase
		TargetStr = TargetStr.ToLowerCase
	End If

	Return (StringToSearch.Length - StringToSearch.Replace(TargetStr,"").Length) / TargetStr.Length

End Sub

Public Sub GetTypes As List
	Dim L As List 
	L.Initialize
	L.AddAll(Array As String( _
	"Activity", _
	"B4xView", _
	"Bitmap", _
	"Button", _
	"Boolean", _
	"Byte", _
	"Canvas", _
	"Checkbox", _
	"Char", _
	"ColorDrawable", _
	"ComboBox", _
	"Context", _
	"Double", _
	"Drawable", _
	"EditText", _
	"File", _
	"Float", _
	"Font", _
	"Form", _
	"InputStream", _
	"Int", _
	"Intent", _
	"JavaObject", _
	"Label", _
	"List", _
	"ListView", _
	"Long", _
	"Map", _
	"Matcher", _
	"MediaPlayer", _
	"Node", _
	"Object", _
	"OutputStream", _
	"PackageManager", _
	"Pane", _
	"Panel", _
	"Path", _
	"Phone", _
	"ProgressBar", _
	"RadioButton", _
	"RandomAccessFile", _
	"Rect", _
	"RichString", _
	"RichStringBuilder", _
	"RichStringFormatter", _
	"SeekBar", _
	"Short", _
	"Spinner", _
	"StateListDrawable", _
	"String", _
	"TextArea", _
	"TextField", _
	"Timer", _
	"Togglebutton", _
	"Tooltip", _
	"Typeface", _
	"Uri", _
	"View", _
	"WebView" _
	))
	Return L
End Sub