﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
#Event: TextChanged (Old As String, New As String)
#Event: MouseClicked (EventData As MouseEvent)
#Event: FocusChanged (HasFocus As Boolean)

#DesignerProperty: Key: Prompt, DisplayName: Prompt, FieldType: String, DefaultValue: Prompt , Description: Prompt
#DesignerProperty: Key: Editable, DisplayName: Editable, FieldType: Boolean, DefaultValue: True , Description: Editable
#DesignerProperty: Key: LineColour, DisplayName: Line Color, FieldType: Color, DefaultValue: 0xFFD3D3D3, Description: Set the color for alternate lines
Sub Class_Globals
	Private fx As JFX
	Private mTA As TextArea
	Dim TAJO As JavaObject
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private LineColor As Paint
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	mTA.Initialize("TA")
	TAJO = mTA
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	mBase.AddNode(mTA,0,0,mBase.PrefWidth,mBase.PrefHeight)
	
	'Copy the styles and configuration from the designer
	mTA.Style = Lbl.Style
	mTA.WrapText = Lbl.WrapText
	If Lbl.TooltipText <> "" Then mTA.TooltipText = Lbl.TooltipText
	If Lbl.ContextMenu.IsInitialized Then mTA.ContextMenu = Lbl.ContextMenu
	CSSUtils.SetStyleProperty(mTA,"-fx-text-fill",PaintToString(Lbl.TextColor))
	If Lbl.Text <> "" Then mTA.Text = Lbl.Text
	mTA.Tag = Base.tag

	mTA.Editable = Props.Get("Editable")
	mTA.PromptText = Props.Get("Prompt")

	'Get the line colour
	LineColor = Props.Get("LineColour")
	
	'Wait for the layout to complete to add a listener for changes to the Content pane size
	Sleep(0)
	'Get the content pane
	Dim Content As JavaObject = TAJO.RunMethod("lookup",Array(".content"))
	'Get the layoutbounds property
	Dim LayoutBoundsProperty As JavaObject = Content.RunMethod("layoutBoundsProperty",Null)
	'Create an event
	Dim O As Object = Content.CreateEventFromUI("javafx.beans.value.ChangeListener","ContentResize",Null)
	'add the listener
	LayoutBoundsProperty.RunMethod("addListener",Array(O))
	
	'Update the lined background now
	UpdateBG(Content)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	mTA.PrefWidth = Width
	mTA.PrefHeight = Height
End Sub

#Region Custom View Methods

Public Sub GetBase As Pane
	Return mBase
End Sub

Public Sub getTextArea As TextArea
	Return mTA
End Sub

Private Sub TA_FocusChanged (HasFocus As Boolean)
	If SubExists(mCallBack,mEventName & "_FocusChanged") Then
		CallSubDelayed2(mCallBack,mEventName & "_FocusChanged", HasFocus)
	End If
End Sub

Private Sub TA_MouseClicked (EventData As MouseEvent)
	If SubExists(mCallBack,mEventName & "_MouseClicked") Then
		CallSubDelayed2(mCallBack,mEventName & "_MouseClicked", EventData)
	End If
End Sub

Private Sub TA_TextChanged (Old As String, New As String)
	If SubExists(mCallBack,mEventName & "_TextChanged") Then
		CallSubDelayed3(mCallBack,mEventName & "_TextChanged", Old, New)
	End If
End Sub

#End Region Custom View Methods

#Region Create Lined Background
Private Sub ContentResize_Event (MethodName As String, Args() As Object)
	Dim Content As JavaObject = Sender
	UpdateBG(Content)
End Sub

Private Sub UpdateBG(Content As JavaObject)
	
	'Get the height of the content pane
	Dim Height As Double = Content.RunMethodJO("getLayoutBounds",Null).RunMethod("getHeight",Null)
	
	'The skin holds the Bounds of the Caret which is 2px bigger than the line height
	Dim Skin As JavaObject = TAJO.RunMethod("getSkin",Null)
	Dim LineHeight As Double = Skin.RunMethodJO("getCaretBounds",Null).RunMethod("getHeight",Null) - 2
	
	'Get the offset from the top of the pane to the first text object.
	Dim Offset As Double
	Dim TextClass As JavaObject = TAJO.RunMethod("lookup",Array(".text"))
	
	Offset = TextClass.RunMethodJO("getBoundsInParent",Null).RunMethod("getMinY",Null)

	'Get the layout bounds of the Content pane so we can size the canvas
	Dim C As JavaObject = Content.RunMethod("getBoundsInParent",Null)
	
	'Create the canvas to draw the background on
	Dim CNV As Canvas
	CNV.Initialize("")
	
	'Size the canvas
	CNV.SetSize(C.RunMethod("getWidth",Null),C.RunMethod("getHeight",Null))
	
	For i = Offset To Height Step LineHeight * 2
		CNV.DrawRect(0,i,CNV.Width,LineHeight,LineColor,True,1)
	Next

	'Create a background object to add to the Content pane
	Dim BGSize As JavaObject
	BGSize.InitializeNewInstance("javafx.scene.layout.BackgroundSize",Array(100.0,100.0,True,True,False,False))
	
	Dim BGP As JavaObject
	BGP.InitializeStatic("javafx.scene.layout.BackgroundPosition")
	
	Dim BGI As JavaObject
	BGI.InitializeNewInstance("javafx.scene.layout.BackgroundImage",Array(CNV.Snapshot,"NO_REPEAT","NO_REPEAT",BGP.GetField("CENTER"),BGSize.GetField("DEFAULT")))
	
	'Create an array of type BackgroundImage so we can pass it to the constructor that requires varargs
	Dim BGA As JavaObject
	BGA.InitializeArray("javafx.scene.layout.BackgroundImage",Array(BGI))
	
	'Create the background
	Dim BG As JavaObject
	BG.InitializeNewInstance("javafx.scene.layout.Background",Array(BGA))
	
	'Add the background
	Content.RunMethod("setBackground",Array(BG))

End Sub
#End Region Create Lined Background

#Region Utils
'Return a string representation of a Paint object suitable to pass as a CSS parameter
Private Sub PaintToString(Color As Paint) As String
	Dim P As JavaObject = Color
	Dim S As String = P.RunMethod("toString",Null)
	Log(S)
	Dim R As Int = Bit.ParseInt(S.SubString2(2,4),16)
	Dim G As Int = Bit.ParseInt(S.SubString2(4,6),16)
	Dim B As Int = Bit.ParseInt(S.SubString2(6,8),16)
	Dim A As Int = Bit.ParseInt(S.SubString(8),16)
	Dim DBlA As Double =  A / 255

	Return $"rgba(${R},${G},${B},${DBlA})"$
End Sub
#End Region Utils